/*
 * SPDX-FileCopyrightText: 2018-2020 Bruce Cowan <bruce@bcowan.me.uk>
 *
 * SPDX-License-Identifier: Apache-2.0
 */

#pragma once

#include "macros.h"

#include <stddef.h>

void * check_calloc       (size_t nmemb,
                           size_t size) ATTR_ALLOC_SIZE2(1,2) ATTR_MALLOC;

void * check_malloc       (size_t  size) ATTR_ALLOC_SIZE(1) ATTR_MALLOC;

void * check_reallocarray (void   *ptr,
                           size_t  nmemb,
                           size_t  size) ATTR_ALLOC_SIZE2(2,3) ATTR_MALLOC ATTR_WARN_UNUSED_RESULT;
